/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * Copyright (C) 2006-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://openbluesky.kenai.com
 * SCM: https://kenai.com/hg/openbluesky~src
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.nodes.role.impl;

import javax.annotation.Nonnull;
import lombok.AllArgsConstructor;
import it.tidalwave.util.Finder;
import it.tidalwave.role.Composite;
import it.tidalwave.role.SimpleComposite;
import it.tidalwave.role.Sortable;

/***********************************************************************************************************************
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@AllArgsConstructor
public class SortableCompositeDecorator<Type> implements SimpleComposite<Type> 
  {
    @Nonnull
    private final Composite<Type, Finder<Type>> delegate;
    
    @Nonnull
    private final Sortable sortController;
    
    @Override @Nonnull
    public Finder<Type> findChildren()
      {
        return delegate.findChildren().sort(sortController.getSortCriterion(), sortController.getSortDirection());
      } 
  }
